# -*- coding:utf-8 -*-

# Musician_m
script_name = u'Musician_m'
version=u'3.3' 

# SYMBIAN_UID = 0x100002B6#
# Musician, created by Steve Litchfield, now open source.
# to do: add tap-tempo function
# add louder/quieter metronome (diff samples)
# setting for different piano note lengths (within reason)??
# 2008 01 14 - 2.4 fixed for Nokia E70 - William F. Dudley Jr.
# 2008 01 22 - 3.0 fixed stack overflow problem(s), cleaned up some
#            code, improved response time of piano(). - William F. Dudley Jr.
# 2008 01 22 - 3.1 piano tweak, slight speed increase - SL
"""
  2015-05-21 - 3.2 sound period more exactly, add volume, tuning menu changed,
                   screen changed, piano_key use stack,,etc. - masa
  2015-06-05 - 3.3 add beat(tap) function - masa

Please see the WEB site (http://stevelitchfield.com/musician.htm) about 
original Musician.
I changed it for myself . (last "m" of name means "mod".)
I appreciate to Steve Litchfield.
"""

import sys,os
sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

import appuifw
from graphics import *
import e32
from key_codes import *
from appuifw import *
import audio
import sysinfo
import time

soundflag=1 #1:audio on
registered=0
Tempo_Volume = 4
Tune_Volume  = 3
Piano_Volume = 4
tuninglength=0

Loop_flag = 1      # global variable
tempo = 0
Beat = None  # beat id (0:no 1:2 2:3 2:3,,,5:6  None:initial value at starting)
Volume_Max = 9
bg_color  = 0xa39974 #background color
bg_color1 = 0xb3a984 #background color of text area
Log_level=0
Log = []

timer = e32.Ao_timer()
app_lock = e32.Ao_lock()

class Keyboard(object):
    def __init__(self,onevent=lambda:None):
        self._keyboard_state={}
        self._downs={}
        self._onevent=onevent
        self.last_key = []

    def handle_event(self,event):
        if event['type'] == appuifw.EEventKeyDown:
            code=event['scancode']
            self.last_key.append(code)
            if not self.is_down(code):
                self._downs[code]=self._downs.get(code,0)+1
            self._keyboard_state[code]=1
        elif event['type'] == appuifw.EEventKeyUp:
            self._keyboard_state[event['scancode']]=0
        self._onevent()

    def is_down(self,scancode):
        return self._keyboard_state.get(scancode,0)

    def pressed(self,scancode):
        if self._downs.get(scancode,0):
            self._downs[scancode]-=1
            return True
        return False

    def get_last_key(self):
        if self.last_key:
            return self.last_key[0]
        return None

    def clear_last_key(self):
        if self.last_key:
            self.last_key.pop(0)

keyboard=Keyboard()

appuifw.app.screen='full'
img=None

def handle_redraw(rect):
    if img:
        canvas.blit(img)

appuifw.app.body=canvas=appuifw.Canvas(
                 event_callback=keyboard.handle_event,
                 redraw_callback=handle_redraw)

img=Image.new(canvas.size) # (a 2 element tuple)
[width,height]=img.size

# sound files put in a list for elegance sake 
soundfiles = [
        "metronome.wav", "metronomech.wav", "metronomepi.wav", 
#        "metronome.wav",
        "a1.mp3", "a3.mp3", "b2.mp3", "c2.mp3", "d1.mp3", "e0.mp3", "e2.mp3", "g1.mp3",
#        "a.mid", "b.mid", "d.mid", "e.mid", "g.mid",
        "pc.mid",
        "pcsharp.mid",
        "pd.mid",
        "pdsharp.mid",
        "pe.mid",
        "pf.mid",
        "pfsharp.mid",
        "pg.mid",
        "pgsharp.mid",
        "pa.mid",
        "pbflat.mid",
        "pb.mid",
        "ptopc.mid" ]


def cache_files():
    # check file exist or not in RAM, then copy to RAM if not already there
    # put sound file in RAM drive for better performance
    cnt0 = cnt1 = 0 # error counter
    file_list = ''

    for filename in soundfiles:
        fromfile = "E:\\musician\\%s" % filename
        tofile = "D:\\%s" % filename
        if not os.path.exists(tofile):
            if os.path.exists(fromfile):
                try:
                    e32.file_copy(tofile, fromfile)
                except:
                    cnt0 += 1
                    file_list = file_list + filename + ', '
            else:
                cnt1 += 1
                file_list = file_list + filename + ', '
    if cnt0 or cnt1:
        appuifw.query((u'File cache error !\n  %s: copy error\n  %s: no file\nY/N, show error file(s)' % 
                         (str(cnt0), str(cnt1))), 'query')
        appuifw.query((u'Y/N, go to Exit\nError file(s):\n  %s' % file_list), 'query')
        return False
    return True


keycode2filename = {
    EScancodeStar : "D:\\pc.mid",
    EScancode7 : "D:\\pcsharp.mid",
    EScancode4 : "D:\\pd.mid",
    EScancode1 : "D:\\pdsharp.mid",
    EScancode0 : "D:\\pe.mid",
    EScancode8 : "D:\\pf.mid",
    EScancode5 : "D:\\pfsharp.mid",
    EScancode2 : "D:\\pg.mid",
    EScancodeHash : "D:\\pgsharp.mid",
    EScancode9 : "D:\\pa.mid",
    EScancode6 : "D:\\pbflat.mid",
    EScancode3 : "D:\\pb.mid",
    EScancodeBackspace : "D:\\ptopc.mid"
    }


def get_volume_max():
    global Volume_Max
    filename = keycode2filename[EScancode0]
    S = audio.Sound.open(filename)
    Volume_Max = S.max_volume()
    S.close()


def calc_volume(volume=4, adj=1):
    tmpV = volume + adj
    if tmpV < 0 : tmpV = 0
    if tmpV > Volume_Max : tmpV = Volume_Max
    return tmpV


def piano():
    global Piano_Volume
    global Loop_flag

    filename = "E:\\Musician\\keyboard%3d.raw" % width
    img.load(filename ,callback=handle_redraw)
    handle_redraw(())

    delay=0.01 # delay means that loop doesn't burn round so fast that nothing works
    S = None
    lastfilename = "silence"
    filename = None
    Loop_flag = 1
    while Loop_flag:
        tmp_last_key = keyboard.get_last_key()
        keyboard.clear_last_key()
        if keyboard.pressed(EScancodeLeftSoftkey):  #want to exit piano
            if S is not None:
                S.stop()
            break
        elif keyboard.pressed(EScancodeDownArrow) : # Decrease volume
            Piano_Volume = calc_volume(Piano_Volume, -1)
        elif keyboard.pressed(EScancodeUpArrow): # Increase volume
            Piano_Volume = calc_volume(Piano_Volume, 1)

        if (tmp_last_key and keycode2filename.has_key(tmp_last_key)):
            filename = keycode2filename[tmp_last_key]
            if(filename != lastfilename):
                if S is not None:
                    S.close()
                S = audio.Sound.open(filename)
                lastfilename = filename
            S.set_volume(Piano_Volume)
            S.play(1,0,cb)
        else:
            timer.after(delay, timer_cb)
        e32.ao_yield()
        app_lock.wait()


def calcdelay(tempo):
    wk=float(60)/float(tempo)
    return  wk-0.02, wk*1.02, wk*0.984 #delay timer value, upper limit, lower limit


def writetempo(msg):
    h1 = height/3
    h2 = height - h1 - 40
    img.rectangle((0,h1,width,h2),bg_color1, fill=bg_color1) #blank previous value
    img.text((10,height/2.0-10), msg , font='normal') 


Sound_id_Lists = [[1,2],                 # no beat    0:pi  sound
                  [0,1],                 # 2          1:chi sound
                  [0,1,2,0,1,2],         # 3
                  [0,1,2,1],             # 4
                  [0,1,2,1,2,0,1,2,1,2], # 5
                  [0,1,2,1,2,1]]         # 6

Display_id_Lists = [[1,2],                # no beat   0:left  red
                    [0,2],                # 2 beat    1:left  green
                    [0,2,1,3,1,2],        # 3 beat    2:right green
                    [0,2,1,2],            # 4         3:right red
                    [0,2,1,2,1,3,1,2,1,2],# 5
                    [0,2,1,2,1,2]]        # 6

Beat_m_list = [u'No', u'2', u'3', u'4', u'5', u'6']


def metronome(init=1):
    global soundflag
    global Tempo_Volume
    global Loop_flag
    global tempo, Beat, Log

    if init == 1:
        tempo = 0    #display tempo query
        Beat = None  #display Beat selection
    while (tempo<40 or tempo>200): # got to make sure the number's sensible!
        tempo = appuifw.query(u"Tempo (40 to 200):", "number", 60)
        if tempo == None:
            return
        if (tempo<40 or tempo>200):
            appuifw.note(u"Tempo out of range (40 to 200)", "error")
    if Beat == None: 
        Beat = appuifw.popup_menu(Beat_m_list, u'Beat select')
        if Beat == None:
            return
    sound_id_list = Sound_id_Lists[Beat]
    display_id_list = Display_id_Lists[Beat]

    delay, period_upper_limit, period_lower_limit = calcdelay(tempo)
    
    if soundflag == 1:
        S0 = audio.Sound.open("D:\\metronomepi.wav")
        S1 = audio.Sound.open("D:\\metronomech.wav")
        S2 = audio.Sound.open("D:\\metronomech.wav")

    writetempo(u'Tempo: %s  Beat: %s' % (str(tempo),Beat_m_list[Beat]))

    metroheight = height/5
    Loop_flag = 1
    tap_counter = 0       #cyclic counter for list index (Sound_id_Lists,,)
    error_conuter = 0     #counter (period limit over error)
    pre_counter = 4       #suppress check of busy error (4 times)
    clock_new = clock_old = time.clock() #for calculate elapse
    sound_id = 0

    while Loop_flag:
        clock_old = clock_new
        clock_new = time.clock()
        elapse = clock_new - clock_old

        #Check period upper limit
        if elapse > period_upper_limit :
            error_conuter += 1
            if error_conuter > 4:
                if soundflag == 1:
                    S0.stop()
                    S0.close()
                    S1.stop()
                    S1.close()
                    S2.stop()
                    S2.close()
                appuifw.query(u"Tempo is too fast*\n tempo down or\n set audio off", "query")
                break
        else:
            if error_conuter > 0:
                error_conuter -= 1

        # Check period lower/upper limit
        # 1st time:elapse nearly 0, 2nd/3rd times:little short
        if pre_counter < 3:
            if elapse <= period_lower_limit: 
                diff = (period_lower_limit - elapse)*0.9
                if diff < 0.002 : diff = 0.002
                delay = delay + diff
            elif elapse >= period_upper_limit:
                diff = (elapse - period_upper_limit)*0.6
                if diff < 0.001 : diff = 0.001
                delay = delay - diff

        timer.after(delay, timer_cb)

        if soundflag == 1 :
            sound_id = sound_id_list[tap_counter]
            if pre_counter > 0:
                pre_counter -= 1
            else: # pre_counter==0
               if (sound_id == 0 and S0.state() == audio.EPlaying) or \
                  (sound_id == 1 and S1.state() == audio.EPlaying) or \
                  (sound_id == 2 and S2.state() == audio.EPlaying):
                    S0.stop
                    S1.stop
                    S2.stop
                    timer.cancel()
                    appuifw.query(u"Tempo is too fast,\n tempo down or\n set audio off", "query")
                    break
            try:
                if sound_id == 0:
                    S0.set_volume(Tempo_Volume)
                    S0.play()
                elif sound_id == 1:
                    S1.set_volume(Tempo_Volume)
                    S1.play()
                else:
                    S2.set_volume(Tempo_Volume)
                    S2.play()
            except RuntimeError:
                if pre_counter > 0:
                    pass
                else: # pre_counter==0
                    S0.stop
                    S1.stop
                    S2.stop
                    timer.cancel()
                    appuifw.query(u"Tempo is too fast;\n tempo down or\n set audio off", "query")
                    break
        display_id = display_id_list[tap_counter]
        img.rectangle((0, 0, width, metroheight),bg_color, fill=bg_color) #clear
        if display_id == 0:
            img.rectangle((0,0,width/4,metroheight),0xff0000, fill=0xff0000)
        elif display_id == 1:
            img.rectangle((0,0,width/4,metroheight),0x00ff00, fill=0x00ff00)
        elif display_id == 2:
            img.rectangle((width*3/4, 0, width, metroheight),0x00ff00, fill=0x00ff00)
        else:
            img.rectangle((width*3/4, 0, width, metroheight),0xff0000, fill=0xff0000)
        handle_redraw(())

        tap_counter += 1
        if tap_counter >= len(sound_id_list):
            tap_counter = 0

        if keyboard.pressed(EScancodeLeftSoftkey):  #want to exit metronome
            if soundflag == 1:
                S0.stop()
                S0.close()
                S1.stop()
                S1.close()
                S2.stop()
                S2.close()
            timer.cancel()
            break
        elif (keyboard.pressed(EScancodeRightArrow)):
            #increase tempo
            tempo=tempo+1
            if tempo > 220 : tempo = 220
            delay, period_upper_limit, period_lower_limit = calcdelay(tempo)
            writetempo(u'Tempo: %s  Beat: %s' % (str(tempo),Beat_m_list[Beat]))
        elif (keyboard.pressed(EScancodeLeftArrow)):
            #reduce tempo
            tempo=tempo-1
            if tempo < 40 : tempo = 40
            delay, period_upper_limit, period_lower_limit = calcdelay(tempo)
            writetempo(u'Tempo: %s  Beat: %s' % (str(tempo),Beat_m_list[Beat]))
        elif keyboard.pressed(EScancodeDownArrow) : # Decrease volume
            Tempo_Volume = calc_volume(Tempo_Volume, -1)
        elif keyboard.pressed(EScancodeUpArrow): # Increase volume
            Tempo_Volume = calc_volume(Tempo_Volume, 1)
        #Reset the user inactivity time, turning the backlight on
        if tap_counter == 0:
            e32.reset_inactivity()
        app_lock.wait()

        # trace
        if Log_level==1:
            L = [elapse, tempo, delay]
            Log.append(L)


def timer_cb():
    app_lock.signal()


def cb(previous, current, err):
    if current != audio.EPlaying: # not at start
        app_lock.signal()


keycode2index = {
    EScancode1 : 0,
    EScancode2 : 1,
    EScancode3 : 2,
    EScancode4 : 3,
    EScancode5 : 4,
    EScancode6 : 5 }

tuning_note_lists = [ ['e2', 'b2', 'g1', 'd1', 'a1', 'e0'],  # Prime
                      ['a3', 'e2', 'c2', 'g1', 'd1', 'a1'] ] # Alto

tuning_page_msg = [u"1-6: E B G D A E" , # Prime
                   u"1-6: A E C G D A" ] # Alto


def tuning(flg=0):
    # flg 0:Prime guitar,  1:Alto guitar
    global Loop_flag
    global Tune_Volume

    msg = tuning_page_msg[flg]
    note_list = tuning_note_lists[flg]

    delay=0.01 # delay means that loop doesn't burn round so fast that nothing works
    Loop_flag = 1
    index = None

    while Loop_flag:
        writetempo(msg)
        handle_redraw(())
        tmp_last_key = keyboard.get_last_key()
        keyboard.clear_last_key()
        if keyboard.pressed(EScancodeLeftSoftkey):  #want to exit
            break
        elif keyboard.pressed(EScancodeDownArrow) : # Decrease volume
            Tune_Volume = calc_volume(Tune_Volume, -1)
        elif keyboard.pressed(EScancodeUpArrow): # Increase volume
            Tune_Volume = calc_volume(Tune_Volume, 1)

        if (tmp_last_key and keycode2index.has_key(tmp_last_key)):
            index = keycode2index[tmp_last_key]
            note = note_list[index]
            playtuning(note)
        else:
            timer.after(delay, timer_cb)
            e32.ao_yield()
            app_lock.wait()


def playtuning(note):
    global Tune_Volume
    img.clear(bg_color)
    handle_redraw(())
    filename = 'D:\\%s.mp3' % note
    writetempo(u'Tune to: %s' % note[0].upper())
    S = audio.Sound.open(filename) # S is local variable
    S.set_volume(Tune_Volume)
    S.play((tuninglength+1)*4, 0, cb)
    app_lock.wait()
    S.stop()
    S.close()


def settings():
    global soundflag, tuninglength
    global Tempo_Volume, Tune_Volume, Piano_Volume
    global Log_level

    state = [u'Off', u'On']
    tvalue = [u'1 bar',u'2 bars', u'3 bars',u'4 bars']
    vvalue = [u'%s' % str(x) for x in range(Volume_Max+1)]

    data = [(u"Audible metronome",'combo',(state, soundflag)), 
            (u'Tempo volume','combo', (vvalue, Tempo_Volume)),
            (u'Tune volume','combo', (vvalue, Tune_Volume)),
            (u'Piano volume','combo', (vvalue, Piano_Volume)),
            (u'Tuning length','combo', (tvalue, tuninglength)),
            (u'Log_level','combo', (state, Log_level))]

    flags = appuifw.FFormEditModeOnly+appuifw.FFormDoubleSpaced
    f = appuifw.Form(data, flags)
    
    # make the form visible on the UI
    f.execute()
    soundflag    = int(f[0][2][1])
    Tempo_Volume = int(f[1][2][1])
    Tune_Volume  = int(f[2][2][1])
    Piano_Volume = int(f[3][2][1])
    tuninglength = int(f[4][2][1])
    Log_level    = int(f[5][2][1])


def write_settings():
    global registered
    global soundflag, tuninglength
    global Tempo_Volume, Tune_Volume, Piano_Volume
    global Log_level

    CONFIG_DIR='E:\\musician'
    CONFIG_FILE=os.path.join(CONFIG_DIR,'musician_m.set')
    if not os.path.isdir(CONFIG_DIR):
        os.makedirs(CONFIG_DIR)
        CONFIG_FILE=os.path.join(CONFIG_DIR,'musician_m.set')      
    config={}
    config['registered']= registered
    config['sound']= soundflag
    config['tempovolume']= Tempo_Volume
    config['tunevolume']= Tune_Volume
    config['pianovolume']= Piano_Volume
    config['tuninglength']= tuninglength
    config['loglevel']= Log_level
    f=open(CONFIG_FILE,'wt')
    f.write(repr(config))
    f.close()


def read_settings():
    global registered
    global soundflag, tuninglength
    global Tempo_Volume, Tune_Volume, Piano_Volume
    global Log_level

    CONFIG_FILE='E:\\musician\\musician_m.set'
    try:
        f=open(CONFIG_FILE,'rt')
        try:
            content = f.read()
            config=eval(content)
            f.close()

            tmpD = int(config.get('registered','0')) 
            if tmpD < 2: registered = tmpD            # else ,use initial value
            tmpD = int(config.get('sound','1'))
            if tmpD < 2: soundflag = tmpD
            tmpD = int(config.get('tempovolume','4'))
            if tmpD <= Volume_Max: Tempo_Volume = tmpD
            tmpD = int(config.get('tunevolume','3'))
            if tmpD <= Volume_Max: Tune_Volume = tmpD
            tmpD = int(config.get('pianovolume','4'))
            if tmpD <= Volume_Max: Piano_Volume = tmpD
            tmpD = int(config.get('tuninglength','0'))
            if tmpD < 4: tuninglength = tmpD # 4 means len(tvalue) in settings()
            tmpD = int(config.get('loglevel','0'))
            if tmpD < 2: Log_level = tmpD
        except:
            appuifw.note(u"Cannot read settings file", "error")
    except:
        appuifw.note(u"Creating settings file", "info")


def exit_key_handler():
    global Loop_flag
    Loop_flag = 0
    timer.cancel()
    app_lock.signal() 


def quit():
    write_settings()


def about():
    appuifw.query((u"%s v%s\n(C) 2006-2008 Steve Litchfield\nhttp://stevelitchfield.com/  , 2015 masa" \
                  % (script_name, version)), "query")


def view_log():
    if Log_level==0 or len(Log)==0:
        return
    dtwk = u'metronome period log\nelapse   ratio      delay\n'
    for x in Log:
        wk=float(60)/float(x[1])
        dtwk=dtwk+(u'%6.4f  %05.1f%s  %6.4f\n' % (x[0], (x[0]*100.0/wk), '%', x[2]))
    textbody = appuifw.Text()
    appuifw.app.body=textbody
    textbody.color=0x222222
    textbody.set(dtwk)
#    textbody.focus = False
    appuifw.app.menu=[(u'Exit', exit_key_handler)]
    app_lock.wait()


def menu():
    L = [u"Metronome", u"Restart (same tempo)", u"Tune Guitar", u"Tune Alto guitar",
         u"Piano", u"Settings", u"About", u"Exit"]
    while 1:
        img.clear(bg_color)
        handle_redraw(())
        keyboard.__init__()

        index = appuifw.popup_menu(L)
        if index == 0:
            metronome(init=1)
        elif index == 1:
            metronome(init=0) #restart same tempo
        elif index == 2:
            tuning(flg=0) #Prime guitar
        elif index == 3:
            tuning(flg=1) #Alto guitar
        elif index == 4:
            piano()
        elif index == 5:
            settings()
        elif index == 6:
            about()
        elif index == 7:
            quit()
            break
        else:
            pass


appuifw.app.title = script_name
appuifw.app.exit_key_handler = exit_key_handler
appuifw.app.screen='normal'

read_settings()
no_error = cache_files()
if no_error:
    get_volume_max()
    menu()
    view_log()

#appuifw.app.set_exit()
#sys.exit()
